<?php
class Registration
{
    private $db_connection = null;
    public $errors = array();
    public $messages = array();

    /**
     * the function "__construct()" automatically starts whenever an object of this class is created,
     * you know, when you do "$registration = new Registration();"
     */
    public function __construct()
    {
        if (isset($_POST["register"])) {
            $this->registerNewUser();
        }
    }

    /**
     * handles the entire registration process. checks all error possibilities
     * and creates a new user in the database if everything is fine
     */
    private function registerNewUser()
    {
	global $afix;
	$checkmdp =false;
	$this->db_connection = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);
    // change character set to utf8 and check it
    if (!$this->db_connection->set_charset("utf8")) {
        $this->errors[] = $this->db_connection->error;
        }

        // if no connection errors (= working database connection)
        if (!$this->db_connection->connect_errno) {
			$user_name= $_SESSION['user_name'];
			$sql = "SELECT user_password_hash
                        FROM ". $afix ."_utilisateurs
                        WHERE user_name = '" . $user_name . "';";
            $result_of_login_check = $this->db_connection->query($sql);

            // if this user exists
            if ($result_of_login_check->num_rows == 1) {
                // get result row (as an object)
                $result_row = $result_of_login_check->fetch_object();
                    // using PHP 5.5's password_verify() function to check if the provided password fits
                    // the hash of that user's password
                    if (password_verify($_POST['user_password'], $result_row->user_password_hash)) {
						$checkmdp=true;
					}
				}
		}
        if (empty($_POST['user_password'])) {
            $this->errors[] = "Le mot de passe actuel est vide";
		} elseif ($checkmdp== false){
			$this->errors[] = "Le mot de passe actuel ne correspond pas";
        } elseif (empty($_POST['user_password_new']) || empty($_POST['user_password_repeat'])) {
            $this->errors[] = "Le nouveau mot de passe est vide";
		} elseif ($_POST['user_password'] == $_POST['user_password_new']) {
            $this->errors[] = "Veuillez entrer un mot de passe diff&eacute;ent du mot de passe actuel.";
        } elseif ($_POST['user_password_new'] !== $_POST['user_password_repeat']) {
            $this->errors[] = "Les mots de passe ne correspondent pas";
        } elseif (!preg_match('/^(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)(?=.*\W+)\S{6,20}$/', $_POST['user_password_new'])) {
            $this->errors[] = "Le mot de passe doit comporter au moins une minuscule, une majuscule, un chiffre et un caract&egrave;re sp&eacute;cial et doit avoir une longueur comprise entre 6 et 20 caract&egrave;res";
        } elseif (!empty($_POST['user_password']) 
			&& !empty($_POST['user_password_new']) 
			&& !empty($_POST['user_password_repeat'])
			&& $_POST['user_password'] != $_POST['user_password_new']
			&& ($checkmdp== true)
            && preg_match('/^(?=.*?[a-z])(?=.*?[A-Z])(?=.*?\d)(?=.*\W+)\S{6,20}$/', $_POST['user_password_new'])
            && ($_POST['user_password_new'] === $_POST['user_password_repeat'])
        ) {
			
            // if no connection errors (= working database connection)
            if (!$this->db_connection->connect_errno) {


                $user_password = $_POST['user_password_new'];
				
                // crypt the user's password with PHP 5.5's password_hash() function, results in a 60 character
                // hash string. the PASSWORD_DEFAULT constant is defined by the PHP 5.5, or if you are using
                // PHP 5.3/5.4, by the password hashing compatibility library
                $user_password_hash = password_hash($user_password, PASSWORD_DEFAULT);

                // check if user or email address already exists
//                $sql = "SELECT * FROM ". $afix ."_utilisateurs WHERE user_name = '" . $user_name . "' ;";
//                $query_check_user_name = $this->db_connection->query($sql);

///                if ($query_check_user_name->num_rows == 1) {
///                  $this->errors[] = "Identifiant d&eacute;j&agrave; utilis&eacute;.";
///               } else {
                    // write new user's data into database
///                   $sql = "INSERT INTO ". $afix ."_utilisateurs (user_password_hash)
///                            VALUES('" . $user_password_hash . "');";
					$sql="UPDATE `". $afix ."_utilisateurs` SET `". $afix ."_utilisateurs`.`user_password_hash` = '$user_password_hash' WHERE `". $afix ."_utilisateurs`.`user_name` ='$user_name'" ;	
                    
					$query_new_mdp_insert = $this->db_connection->query($sql);

                    // if user has been added successfully
                    if ($query_new_mdp_insert) {
                       $this->messages[] = "Votre mot de passe a bien &eacute;t&eacute; modifi&eacute;";
                    } else {
                       $this->errors[] = "Echec, veuillez ressayer.";
                    }
 ///               }
            } else {
                $this->errors[] = "Sorry, no database connection.";
            }
        } else {
            $this->errors[] = "An unknown error occurred.";
        }
    }

}