<?php

/**
 * Class registration
 * handles the user registration
 */
class Registration
{
    /**
     * @var object $db_connection The database connection
     */
    private $db_connection = null;
    /**
     * @var array $errors Collection of error messages
     */
    public $errors = array();
    /**
     * @var array $messages Collection of success / neutral messages
     */
    public $messages = array();

    /**
     * the function "__construct()" automatically starts whenever an object of this class is created,
     * you know, when you do "$registration = new Registration();"
     */
    public function __construct()
    {
        if (isset($_POST["register"])) {
            $this->registerNewUser();
        }
    }

    /**
     * handles the entire registration process. checks all error possibilities
     * and creates a new user in the database if everything is fine
     */
    private function registerNewUser()
    {
	global $afix;
        if (empty($_POST['user_name'])) {
            $this->errors[] = "L&#145;identifiant est vide";
		} elseif (empty($_POST['nom'])) {
            $this->errors[] = "Le nom est vide";
		} elseif (empty($_POST['prenom'])) {
            $this->errors[] = "Le pr&eacute;nom est vide";
        } elseif (empty($_POST['user_password_new']) || empty($_POST['user_password_repeat'])) {
            $this->errors[] = "Le mot de passe est vide";
        } elseif ($_POST['user_password_new'] !== $_POST['user_password_repeat']) {
            $this->errors[] = "Les mots de passe ne correspondent pas";
        } elseif (strlen($_POST['user_password_new']) < 6) {
            $this->errors[] = "Le mot de passe doit avoir une longueur de 6 caract&egrave;res minimum.";
        } elseif (strlen($_POST['user_name']) > 64 || strlen($_POST['user_name']) < 2) {
            $this->errors[] = "L&#145;identifiant doit avoir entre 2 et 64 caract&egrave;res.";
        } elseif (!preg_match('/^[a-z\d]{2,64}$/i', $_POST['user_name'])) {
            $this->errors[] = "L&#145;identifiant  doit comporter uniquement les caract&egrave;res a-Z ou des chiffres, et doit avoir entre 2 et 64 caract&egrave;res";
        //} elseif (empty($_POST['user_email'])) {
        //    $this->errors[] = "Le champ Statut ne doit pas être vide";
        //} elseif (strlen($_POST['user_email']) > 64) {
        //    $this->errors[] = "Le champ status doit avoir enytre 2 et 64 caractères";
        //} elseif (!filter_var($_POST['user_email'], FILTER_VALIDATE_EMAIL)) {
            //$this->errors[] = "Your email address is not in a valid email format";
        } elseif (!empty($_POST['user_name']) 
			&& !empty($_POST['nom']) 
			&& !empty($_POST['prenom'])
            && strlen($_POST['user_name']) <= 64
            && strlen($_POST['user_name']) >= 2
            && preg_match('/^[a-z\d]{2,64}$/i', $_POST['user_name'])
			&& strlen($_POST['nom']) <= 50
            && preg_match('/^[a-z\d]{2,64}$/i', $_POST['nom'])
			&& strlen($_POST['prenom']) <= 50
            && preg_match('/^[a-z\d]{2,64}$/i', $_POST['prenom'])
            //&& !empty($_POST['user_email'])
            //&& strlen($_POST['user_email']) <= 64
            //&& filter_var($_POST['user_email'], FILTER_VALIDATE_EMAIL)
            && !empty($_POST['user_password_new'])
            && !empty($_POST['user_password_repeat'])
            && ($_POST['user_password_new'] === $_POST['user_password_repeat'])
        ) {
            // create a database connection
            $this->db_connection = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);

            // change character set to utf8 and check it
            if (!$this->db_connection->set_charset("utf8")) {
                $this->errors[] = $this->db_connection->error;
            }

            // if no connection errors (= working database connection)
            if (!$this->db_connection->connect_errno) {

                // escaping, additionally removing everything that could be (html/javascript-) code
                $user_name = $this->db_connection->real_escape_string(strip_tags($_POST['user_name'], ENT_QUOTES));
				$nom = $this->db_connection->real_escape_string(strip_tags($_POST['nom'], ENT_QUOTES));
				$prenom = $this->db_connection->real_escape_string(strip_tags($_POST['prenom'], ENT_QUOTES));
                //$user_email = $this->db_connection->real_escape_string(strip_tags($_POST['user_email'], ENT_QUOTES));

                $user_password = $_POST['user_password_new'];

                // crypt the user's password with PHP 5.5's password_hash() function, results in a 60 character
                // hash string. the PASSWORD_DEFAULT constant is defined by the PHP 5.5, or if you are using
                // PHP 5.3/5.4, by the password hashing compatibility library
                $user_password_hash = password_hash($user_password, PASSWORD_DEFAULT);

                // check if user or email address already exists
                $sql = "SELECT * FROM ". $afix ."_utilisateurs WHERE user_name = '" . $user_name . "' ;";
                $query_check_user_name = $this->db_connection->query($sql);

                if ($query_check_user_name->num_rows == 1) {
                    $this->errors[] = "Identifiant d&eacute;j&agrave; utilis&eacute;.";
                } else {
                    // write new user's data into database
                    $sql = "INSERT INTO ". $afix ."_utilisateurs (user_name, nom, prenom, user_password_hash)
                            VALUES('" . $user_name . "','" . $nom . "','" . $prenom . "','" . $user_password_hash . "');";
							
                    $query_new_user_insert = $this->db_connection->query($sql);

                    // if user has been added successfully
                    if ($query_new_user_insert) {
                        $this->messages[] = "Votre compte a &eacute;t&eacute; cr&eacute;&eacute;, vous pouvez vous connecter.";
                    } else {
                        $this->errors[] = "Echec, veuillez ressayer.";
                    }
                }
            } else {
                $this->errors[] = "Sorry, no database connection.";
            }
        } else {
            $this->errors[] = "An unknown error occurred.";
        }
    }
}
